#ifndef FHGFSOPSHELPER_H_
#define FHGFSOPSHELPER_H_

#include <include_open/common/storage/Open_StorageErrors.h>
#include <include_open/common/Open_Common.h>
#include <include_closed/filesystem/FsDirInfo.h>
#include <include_closed/filesystem/FsFileInfo.h>


extern int FhgfsOpsHelper_refreshDirInfoIncremental(App* app, char* path,
   loff_t currentOffset, FsDirInfo* dirInfo, fhgfs_bool forceUpdate);

extern int FhgfsOpsHelper_symlink(App* app, char* from, const char* to, 
   unsigned userID, unsigned groupID, int mode);
extern int FhgfsOpsHelper_readlink(App* app, char* path, char __user* buf, int size);

extern ssize_t FhgfsOpsHelper_writeStateless(App* app, char* path, const char __user *buf,
   size_t size, loff_t offset);

extern FhgfsOpsErr FhgfsOpsHelper_flushCache(App* app, FsFileInfo* fileInfo,
   fhgfs_bool discardCacheOnError);
extern ssize_t FhgfsOpsHelper_writeCached(App* app, const char __user *buf, size_t size,
   loff_t offset, FsFileInfo* fileInfo);
extern ssize_t FhgfsOpsHelper_readCached(App* app, char __user *buf, size_t size,
   loff_t offset, FsFileInfo* fileInfo);


extern ssize_t __FhgfsOpsHelper_writeCacheFlushed(App* app, const char __user *buf, size_t size,
   loff_t offset, FsFileInfo* fileInfo);
extern ssize_t __FhgfsOpsHelper_readCacheFlushed(App* app, char __user *buf, size_t size,
   loff_t offset, FsFileInfo* fileInfo);


#endif /*FHGFSOPSHELPER_H_*/
