#ifndef FSFILEINFO_H_
#define FSFILEINFO_H_

#include <include_closed/common/Common.h>
#include "FsObjectInfo.h"


enum FsFileCacheType; // forward declaration
struct StripePattern; // forward declaration
struct IntCpyVec; // forward declaration


struct FsFileInfo;
typedef struct FsFileInfo FsFileInfo;


extern void FsFileInfo_init(FsFileInfo* this, App* app, const char* ownerNodeID,
   const char* fileHandleID, unsigned accessFlags, struct StripePattern* pattern);
extern FsFileInfo* FsFileInfo_construct(App* app, const char* ownerNodeID, const char* fileHandleID,
   unsigned accessFlags, struct StripePattern* pattern);
extern void FsFileInfo_uninit(FsObjectInfo* this);
extern void FsFileInfo_destruct(FsObjectInfo* this);

// inliners
extern void FsFileInfo_incCacheHits(FsFileInfo* this, size_t cacheHits);
extern void FsFileInfo_decCacheHits(FsFileInfo* this, size_t cacheHits);

// getters & setters
extern char* FsFileInfo_getOwnerNodeID(FsFileInfo* this);
extern char* FsFileInfo_getFileHandleID(FsFileInfo* this);
extern struct StripePattern* FsFileInfo_getStripePattern(FsFileInfo* this);
extern void FsFileInfo_setAppending(FsFileInfo* this, fhgfs_bool appending);
extern fhgfs_bool FsFileInfo_getAppending(FsFileInfo* this);
extern void FsFileInfo_setMaxUsedNodeIndex(FsFileInfo* this, int maxUsedNodeIndex);
extern int FsFileInfo_getMaxUsedNodeIndex(FsFileInfo* this);
extern unsigned FsFileInfo_getAccessFlags(FsFileInfo* this);
extern size_t FsFileInfo_getCacheHits(FsFileInfo* this);
extern void FsFileInfo_setAllowCaching(FsFileInfo* this, fhgfs_bool allowCaching);
extern fhgfs_bool FsFileInfo_getAllowCaching(FsFileInfo* this);
extern void FsFileInfo_setCacheType(FsFileInfo* this, enum FsFileCacheType cacheType);
extern enum FsFileCacheType FsFileInfo_getCacheType(FsFileInfo* this);
extern size_t FsFileInfo_getCacheID(FsFileInfo* this);


#endif /*FSFILEINFO_H_*/
