#ifndef FHGFSOPSREMOTING_H_
#define FHGFSOPSREMOTING_H_

#include <include_closed/common/Common.h>
#include <include_closed/filesystem/FsObjectInfo.h>
#include <include_closed/filesystem/FsDirInfo.h>
#include <include_closed/filesystem/FsFileInfo.h>
#include <include_closed/common/storage/StorageDefinitions.h>
#include <include_open/common/storage/Open_StorageErrors.h>


extern FhgfsOpsErr FhgfsOpsRemoting_opendir(char* path, FsDirInfo* outDirInfo);
extern FhgfsOpsErr FhgfsOpsRemoting_listdirIncremental(char* path, FsDirInfo* outDirInfo,
   const char* lastEntry, int lastStage, unsigned maxOutNames);
extern FhgfsOpsErr FhgfsOpsRemoting_listdirFromOffset(char* path, FsDirInfo* outDirInfo,
   uint64_t offset, unsigned maxOutNames);
extern FhgfsOpsErr FhgfsOpsRemoting_stat(App* app, char* path, fhgfs_stat* fhgfsStat);
extern FhgfsOpsErr FhgfsOpsRemoting_setAttr(App* app, char* path,
   SettableFileAttribs* fhgfsAttr, int validAttribs);
extern FhgfsOpsErr FhgfsOpsRemoting_mkdir(App* app, char* path, unsigned userID, unsigned groupID,
   int mode);
extern FhgfsOpsErr FhgfsOpsRemoting_rmdir(App* app, char* path);
extern FhgfsOpsErr FhgfsOpsRemoting_mkfile(App* app, char* path, unsigned userID, unsigned groupID,
   int mode);
extern FhgfsOpsErr FhgfsOpsRemoting_unlinkfile(App* app, char* path);
extern FhgfsOpsErr FhgfsOpsRemoting_openfile(App* app, char* path, unsigned flags,
   FsFileInfo** outFileInfo);
extern FhgfsOpsErr FhgfsOpsRemoting_closefile(FsFileInfo* fileInfo);
extern ssize_t FhgfsOpsRemoting_writefile(const char __user *buf, size_t size, loff_t offset,
   FsFileInfo* fileInfo);
//extern ssize_t FhgfsOpsRemoting_writefileThreaded(const char __user *buf, size_t size, loff_t offset,
//   FsFileInfo* fileInfo);
extern ssize_t FhgfsOpsRemoting_readfile(char __user *buf, size_t size, loff_t offset,
   FsFileInfo* fileInfo);
//extern ssize_t FhgfsOpsRemoting_readfileThreaded(char __user *buf, size_t size, loff_t offset,
//   FsFileInfo* fileInfo);
extern FhgfsOpsErr FhgfsOpsRemoting_rename(App* app, char* pathFrom, char* pathTo);
extern FhgfsOpsErr FhgfsOpsRemoting_truncfile(App* app, char* path, loff_t size);
extern FhgfsOpsErr FhgfsOpsRemoting_fsyncfile(FsFileInfo* fileInfo);
extern FhgfsOpsErr FhgfsOpsRemoting_statStoragePath(App* app, int64_t* outSizeTotal,
   int64_t* outSizeFree);



#endif /*FHGFSOPSREMOTING_H_*/
