#include <open/common/Common.h>
#include <include_open/common/threading/Open_Mutex.h>

#if LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,26)
#include <asm/semaphore.h>
#else
#include <linux/semaphore.h>
#endif // LINUX_VERSION_CODE



struct Mutex
{
   struct semaphore sema;
};


void Mutex_init(Mutex* this)
{
   init_MUTEX(&this->sema);
}

Mutex* Mutex_construct(void)
{
   Mutex* this = (Mutex*)os_kmalloc(sizeof(*this) );

   Mutex_init(this);

   return this;
}

void Mutex_uninit(Mutex* this)
{
}

void Mutex_destruct(Mutex* this)
{
   Mutex_uninit(this);

   kfree(this);
}

void Mutex_lock(Mutex* this)
{
   down(&this->sema);
}

void Mutex_unlock(Mutex* this)
{
   up(&this->sema);
}

