#ifndef FHGFSOPS_VERSIONS_H_
#define FHGFSOPS_VERSIONS_H_

#include <include_open/common/Open_Common.h>
#include <open/common/Common.h>
#include <include_closed/app/log/Logger.h>
#include <include_closed/app/App.h>
#include <include_closed/net/filesystem/FhgfsOpsRemoting.h>
#include <include_closed/filesystem/FsDirInfo.h>
#include <include_closed/filesystem/FsFileInfo.h>
#include <include_closed/filesystem/FhgfsOpsHelper.h>

#include <linux/fs.h>
#include <linux/dcache.h>
#include <linux/namei.h>
#include <linux/pagemap.h>
#include <linux/vfs.h>
#include <linux/mount.h>



#if LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,16)
extern struct super_block* __FhgfsOps_getSB(struct file_system_type *fs_type,
   int flags, const char *dev_name, void *data);
#else
extern int __FhgfsOps_getSB(struct file_system_type *fs_type,
   int flags, const char *dev_name, void *data, struct vfsmount *mnt);
#endif // LINUX_VERSION_CODE


#if LINUX_VERSION_CODE <= KERNEL_VERSION(2,6,16)
extern int FhgfsOps_statfs(struct super_block* sb, struct kstatfs* kstatfs);
#else
extern int FhgfsOps_statfs(struct dentry* dentry, struct kstatfs* kstatfs);
#endif // LINUX_VERSION_CODE


#if LINUX_VERSION_CODE >= KERNEL_VERSION(2,6,16)
extern void __FhgfsOps_forceDentryRelease(struct super_block *sb);
#endif // LINUX_VERSION_CODE


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
extern int FhgfsOps_follow_link(struct dentry* dentry, struct nameidata* nd);
#else
extern void* FhgfsOps_follow_link(struct dentry* dentry, struct nameidata* nd);
#endif // LINUX_VERSION_CODE


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,16)
extern void FhgfsOps_put_link(struct dentry *dentry, struct nameidata* nd);
#else
extern void FhgfsOps_put_link(struct dentry *dentry, struct nameidata* nd, void* p);
#endif // LINUX_VERSION_CODE


#if LINUX_VERSION_CODE < KERNEL_VERSION(2,6,18)
extern int FhgfsOps_flush(struct file *file);
#else
extern int FhgfsOps_flush(struct file *file, fl_owner_t id);
#endif // LINUX_VERSION_CODE


#endif /*FHGFSOPS_VERSIONS_H_*/
